#pragma once
#include "DTV_Base.h"
#include "../lib/CyAPI.h"
#include <list>

#define DTV_OPTCUSB2_ASYNC_XFER_REQ_NUM		16
#define DTV_OPTCUSB2_ASYNC_XFER_SIZE		(1024*64)

typedef unsigned char u8;
typedef signed char s8;
typedef unsigned short int u16;
typedef signed short int s16;
typedef unsigned int u32;
typedef signed int s32;

class CDTV_OptCUsb2 : public CDTV_Base
{
public:
	CDTV_OptCUsb2();
	virtual ~CDTV_OptCUsb2(void);

	BOOL Initialize(char *szInitString=NULL,HWND hWnd=NULL,GUID *pGuid=NULL);
		void Release();
	BOOL IsInitialized();

	DWORD GetExtFunction();
	DWORD GetDeviceCount();
	BOOL GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen);
	DWORD GetUsbEndpointCount(int iDevNo);
	BOOL GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo);
	BOOL IsEndpointEffective(int iDevNo,int iUsbEpAddr);

	BOOL Connect(int iDevNo,int iInEpAddr,int iOutEpAddr);
	void DisConnect();
	BOOL IsConnect();

	DWORD XferRequestProc(struct DTV_ThreadParam *lpParameter);
	DWORD XferResponceProc(struct DTV_ThreadParam *lpParameter);

	DWORD GetChannelCount();
	int GetChannelName(int iChIndex,char *lpszChName,int iBufSize);
	BOOL SetChannel(int iCh);
	int GetChannel();
	BOOL SetChannnelByString(char *lpszChStr);
public:
	// pNXƎ

protected:
	// Jnp[^
	struct DTV_EzUSBFX2_ReqParam
	{
		CCyUSBEndPoint	*pEP_In;
		CCyUSBEndPoint	*pEP_Out;
	};
	// 񓯊]L[
	struct DTV_EzUSBFX2_Request
	{
		OVERLAPPED		Overlap;
		CCyUSBEndPoint	*pEndPoint;
		PUCHAR			pContext;

		BYTE buf[DTV_OPTCUSB2_ASYNC_XFER_SIZE];
		LONG buf_len; 
	};

	CCyUSBDevice *m_pCyUSB;								// CypressėpCu
	std::list<struct DTV_EzUSBFX2_Request*>	m_ReqWait;	// NGXg\
	std::list<struct DTV_EzUSBFX2_Request*>	m_ReqBusy;	// NGXg
	CRITICAL_SECTION m_stCS;

	bool bDevNodeChange;
	bool bArrived;
	bool loading;
	bool cons_mode;
	u8 _id;
	bool fwload(u8 id, u8 *fw, u8 *string1);

	BOOL MakeXferQueue();
	void FreeXferQueue();

	void IRCommandTx(WORD* pIRCommand, LONG length);
	CCyUSBEndPoint* m_pEP_Out;
	int m_iChannel;
};
